前言:

推荐免费Java基础入门视频:【狂神说Java】Java零基础学习视频通俗易懂_哔哩哔哩_bilibili

Error和Exception

什么是异常:

  • 实际工作中,遇到的情况不可能是非常完美的。比如:你写的某个模块,用户输入不一定符合你的要求,你的程序要打开某个文件,这个文件可能不存在或者文件格式不对,你要读取数据库的数据,数据可能是空的等。我们的程序再跑着,内存或硬盘可能就满了…
  • 软件程序在运行过程中,非常可能遇到刚刚提到这些异常问题,我们叫异常(Exception),意思是例外。这些,例外情况,或者叫异常,怎么让我们写的程序做出合理的处理。而不至于程序崩溃。
  • 异常指程序运行中出现的不期而至的各种状况,如:文件找不到,网络连接失败,非法参数等。
  • 异常发生在程序运行期间,它影响了正常的程序执行流程。

异常体系结构:

  • Java把异常当作对象来处理,并定义一个基类java.lang.Throwable作为所有异常的超类。

  • 在Java API中已经定义了许多异常类,这些异常类分为两大类,错误Error和异常Exception

    fcxA4P.png

Error:

  • Error类对象由Java虚拟机生成并抛出,大多数错误与代码编写者所执行的操作无关。
  • Java虚拟机运行错误(Virtual MachineError),当JVM不再继续执行操作所需的内存资源时,将出现OutOfMemoryError。这些异常发生时,Java虚拟机(JVM)一般会选择线程终止。
  • 还有发生在虚拟机试图执行应用是,如类定义错误(NoClassDefFoundError)、连接错误(LinkageError)。这些错误时不可查的,因为它们在应用程序的控制和处理能力之外,而且绝大多数时程序运行时不允许出现的状况。

Exception:

  • 在Exception分支中有一个重要的子类RuntimeException(运行时异常)。
  • ArrayIndexOutOfBoundsException(数组下标越界)
  • NullPointerException(空指针异常)
  • ArithmeticException(算数异常)
  • MissingResourceException(丢失资源)
  • ClassNoFoundException(找不到类)等异常,这些异常是不检查异常,程序中可以选择捕获处理,也可以不处理。
  • 这些异常一般时由程序逻辑错误引起的,程序应该从逻辑角度尽可能避免这类异常的发生。
  • Error和Exception的区别:Error通常是灾难性的致命的错误,是程序无法控制和处理的,当出现这些异常时,Java虚拟机(JVM)一般会选择终止线程;Exception通常情况下是可以被程序处理的,并且在程序中应该尽可能的去处理这些异常。

捕获和抛出异常

异常处理机制:

  • 抛出异常
  • 捕获异常
  • 异常处理五个关键字:

    • try,catch,finally,throw,throws
    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    package com.opp.demo08;

    /**
    * @author Joker大雄
    * @data 2021/8/15 - 15:17
    **/
    public class Test {
    public static void main(String[] args) {
    int a=1;
    int b=0;
    //捕获异常
    //finally不是必须的
    //捕获多个异常,从小到大
    //快捷键 Ctrl+Alt+T
    try{
    System.out.println(a/b);
    }catch (ArithmeticException e){ //catch里为想要捕获的异常最高为Throwable
    System.out.println("程序异常,变量b不能为0");
    }finally{
    System.out.println("finally");
    }

    try {
    new Test().test(1,0);
    } catch (Exception e) {
    e.printStackTrace();
    System.out.println("抛出异常");
    }

    }

    //抛出异常
    public void test(int a,int b) throws Exception{
    if(b==0){
    throw new ArithmeticException();//主动抛出异常,一般在方法中使用
    }
    }
    }

自定义异常及小结

自定义异常:

  • 使用Java内置的异常类可以描述在编程时出现的大部分异常情况。除此之外,用户还可以自定义异常。用户自定义异常类,只需要继承Exception类即可。
  • 在程序中使用自定义异常类,大体可分为以下几个步骤:
    • 创建自定义异常类。
    • 在方法中通过throw关键字抛出异常对象。
    • 如果在当前抛出异常的方法中处理异常,可以使用try-catch语句捕获并处理;否则在方法的声明处通过throws关键字指明要抛出给方法调用者的异常,继续进行下一步操作。
    • 在出现异常方法的调用者中捕获并处理异常。

实际应用中的总结:

  • 处理运行时异常,采用逻辑去合理规避同时辅助try-catch处理。

  • 在多重catch块后面,可以加一个catch(Exception)来处理可能会被遗漏的异常。

  • 对于不确定的代码,也可以加上try-catch,处理潜在的异常。

  • 尽量去处理异常,切忌只是简单地调用printStackTrace()去打印输出。

  • 具体如何处理异常,要根据不同的业务需求和异常类型去决定。

  • 尽量添加finally语句块去释放占用的资源。

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    //MyException
    //自定义异常
    public class MyException extends Exception{

    //传递数字>10 抛出异常
    private int detail;

    public MyException(int a){
    this.detail = a;
    }
    //toString : 异常打印

    @Override
    public String toString() {
    return "MyException:" + detail;
    }
    }


    //Test类
    public class Test {
    public static void main(String[] args) {
    try {
    test(11);
    } catch (MyException e) {
    // e.printStackTrace();
    //增加一些处理异常的代码
    System.out.println("MyException=>"+e);
    }
    }
    //可能会有异常的方法
    static void test(int a) throws MyException{
    System.out.println("传递的参数:"+a);
    if(a>10){
    throw new MyException(a);//抛出
    }
    System.out.println("正常");
    }
    }